/* NoSuch MIDI - Copyright 1997-1998 by Tim Thompson */

package com.nosuch.cooking;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import java.net.*;
import com.nosuch.midi.*;

// There is one of these objects for each row in the grid.
class DrumRow implements Externalizable {
	String label;		// The label of the row
	MidiPhrase note;	// The current note being played on this row
	int[] cells;

	public DrumRow() {	// needed by readObject()
	}

	public DrumRow(String lb, MidiPhrase nt, int ns) {
		label = lb;
		note = nt;
		cells = new int[ns];
		for ( int n=0; n<ns; n++ )
			cells[n] = 0;
	}
	public void writeExternal(ObjectOutput out) throws IOException {
		out.writeUTF(label);
		out.writeUTF(note.toString());
		out.writeObject(cells);
	}
	public void readExternal(ObjectInput in) throws IOException {
		label = in.readUTF();
		String nt = in.readUTF();
		note = new MidiPhrase(nt);
		try {
			cells = (int[])in.readObject();
		} catch (ClassNotFoundException e) {
			System.out.println("Error reading external into DrumRow");
			cells = null;
		}
	}
}

