#include <wtypes.h>
#include <ddeml.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#ifdef UNICODE
#define STRICMP wcsicmp
#define ITOA(c, sz, b) (itoa(sizeof(szA), szA, b), mbstowcs(sz, szA, b), sz)
#else
#define STRICMP stricmp
#define ITOA itoa
#endif  // UNICODE

#define DDETIMEOUT 5000

// TCHAR szNetscape[] = TEXT("IEXPLORE"); // DDE service name
TCHAR szNetscape[] = TEXT("NETSCAPE"); // DDE service name

TCHAR szWWW_Exit[] = TEXT("WWW_Exit"); // DDE topic name
TCHAR szWWW_GetWindowInfo[] = TEXT("WWW_GetWindowInfo");    // DDE topic name
TCHAR szWWW_OpenURL[] = TEXT("WWW_OpenURL");    // DDE topic name
TCHAR szWindowID[] = TEXT("dwWindowID");    // DDE topic name

HSZ         hszNetscape = 0;
HSZ         hszWWW_Exit = 0;
HSZ         hszWWW_GetWindowInfo = 0;
HSZ         hszWWW_OpenURL = 0;
HSZ         hszWindowID = 0;
HSZ         hszBuff = 0;

DWORD       idInst = 0;                 // our DDEML instance object
HCONV		hConv = 0;              // the list of all convs we have open
HDDEDATA	hRet;
TCHAR       szT[20];                    // static buffer for painting
#ifdef UNICODE
CHAR        szA[20];                    // static buffer for UNICODE conversion
TCHAR       szTitle[] = TEXT("DDEmo (U)");
#else
TCHAR       szTitle[] = TEXT("DDEmo");
#endif
TCHAR       szApp[] = TEXT("DDEmo");    // DDE service name
TCHAR       szPause[] = TEXT("PAUSE");  // DDE Execute command
TCHAR       szResume[] = TEXT("RESUME");// DDE Execute command
int         InCount = 0;                // static buffer to hold incomming data
int         cConvs = 0;                 // number of active conversations
int         count = 0;                  // our data
int         cyText, cxText, cyTitle;    // sizes for painting

void
debugprintf(char *fmt,...)
{
	va_list args;
	static FILE *f = NULL;

	if ( f == NULL )
		f = fopen("debug.tmp","w");

	va_start(args,fmt);

	if ( f != NULL ) {
		vfprintf(f,fmt,args);
		fflush(f);
	}
	va_end(args);
}

main() {

	char buff[256];
	char *pdata;

    if (DdeInitialize(&idInst, (PFNCALLBACK)0,
            APPCMD_FILTERINITS | APPCMD_CLIENTONLY, 0))
        return(FALSE);

    /*
     * Initialize all our string handles for use later
     */
    hszNetscape = DdeCreateStringHandle(idInst, szNetscape, 0);
    hszWWW_Exit = DdeCreateStringHandle(idInst, szWWW_Exit, 0);
    hszWWW_GetWindowInfo = DdeCreateStringHandle(idInst,szWWW_GetWindowInfo,0);
    hszWWW_OpenURL = DdeCreateStringHandle(idInst,szWWW_OpenURL,0);
    hszWindowID = DdeCreateStringHandle(idInst, szWindowID, 0);

	// Start the conversation to get the URL in the current window
	
    hConv = DdeConnect(idInst, hszNetscape, hszWWW_GetWindowInfo, NULL);

	strcpy(buff,"0xFFFFFFFF");
    hszBuff = DdeCreateStringHandle(idInst, buff, 0);

	hRet = DdeClientTransaction(NULL, 0ul, hConv, hszBuff,
				 CF_TEXT, XTYP_REQUEST, DDETIMEOUT, NULL);
	debugprintf("first hRet=%ld\n",(long)hRet);

	pdata = (char *)DdeAccessData(hRet, NULL);
	debugprintf("URL=%s\n",pdata);

    DdeDisconnect(hConv);

	// Start the conversation to put a URL in the current window
	
    hConv = DdeConnect(idInst, hszNetscape, hszWWW_OpenURL, NULL);

	strcpy(buff,"http://www.nosuch.com/cook/cookget.cgi?id=333,,0xFFFFFFFF,0,,,");
    hszBuff = DdeCreateStringHandle(idInst, buff, 0);

	hRet = DdeClientTransaction(NULL, 0ul, hConv, hszBuff,
				 CF_TEXT, XTYP_REQUEST, DDETIMEOUT, NULL);
	debugprintf("openurl hRet=%ld\n",(long)hRet);

	pdata = (char *)DdeAccessData(hRet, NULL);
	debugprintf("URL=%s\n",pdata);

    DdeDisconnect(hConv);

#ifdef DONOTDO
	// Now start the conversation to exit Netscape.

    hConv = DdeConnect(idInst, hszNetscape, hszWWW_Exit, NULL);
	hRet = DdeClientTransaction(NULL, 0, hConv, hszWWW_Exit,
				 CF_TEXT, XTYP_POKE, DDETIMEOUT, NULL);
	debugprintf("second hRet=%ld\n",(long)hRet);
    DdeDisconnect(hConv);
#endif

    DdeFreeStringHandle(idInst, hszNetscape);
    DdeFreeStringHandle(idInst, hszWWW_Exit);
    DdeFreeStringHandle(idInst, hszWWW_GetWindowInfo);

    DdeUninitialize(idInst);

    return(0);
}
